<template>
  <!-- <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button
      type="primary"
      circle
      v-show="!editable"
      @click="editable = !editable"
      >编辑</el-button
    >
    <el-button type="primary" v-show="editable" @click="saveData"
      >确定</el-button
    >
  </div> -->
  <div id="printContent" ref="imageWrapper">
    <h3>生产停机记录表</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>

      <!-- <div class="title_form_input">
                  <span>生产线：</span>
                  <span>四线</span>
                </div> -->
    </div>
    <el-divider />

    <HJTABLE
      :SClist="SClist"
      :tableHeader="flHeader"
      :editable="editable"
    ></HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { last, save } from "@/api/SCTJapi";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const flHeader = reactive([
      {
        prop: "jitai",
        label: "机台",
        editable: false,
        type: "text",
      },
      {
        prop: "tingjiTime",
        label: "停机时间",
        editable: false,
        type: "input",
      },
      {
        prop: "guzhangYy",
        label: "故障原因",
        editable: false,
        type: "input",
      },
      {
        prop: "tiaozhengFf",
        label: "调整方法",
        editable: false,
        type: "text",
      },
      {
        prop: "jianceItem",
        label: "检查项目",
        editable: false,
        type: "input",
      },
      {
        prop: "jianceNum",
        label: "检查数量",
        editable: false,
        type: "text",
      },
      {
        prop: "kaijiTime",
        label: "开机时间",
        editable: false,
        type: "input",
      },
      {
        prop: "jianceJg",
        label: "检查结果",
        editable: false,
        type: "text",
      },
      {
        prop: "querenName",
        label: "确认人",
        editable: false,
        type: "input",
      },
      {
        prop: "tiaozhengTime",
        label: "调整时长",
        editable: false,
        type: "text",
      },
      {
        prop: "chuliName",
        label: "处理人",
        editable: false,
        type: "input",
      },
    ]);

    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });

    let SClist = ref([]);
    let hjData = ref({});
    let labelName = {
      b1: "生产记录",
      b2: "废品统计",
      b3: "质量记录",
      b4: "辅料检查记录",
    };
    let editable = ref(false);

    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    const getListData = async () => {
      const data = await last();
      headData.head = data.data.head;
      headData.head.reportTime = headData.head.reportTime.substr(0, 10);

      console.log("jiguan....", data);
      hjData.value = {
        ...headData.head,
      };

      // tableHeader.forEach(e=>{
      //   // SClist.push({e.})
      // })

      SClist.value = data.data.shengchanTjList;
    };

    const saveData = async () => {
      editable = false;
      let data = {
        shengchanTjList: SClist.value,
        head: headData.head,
      };
      console.log("save data...", data);
      const dt = await save(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "集罐机工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("jiguan2.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象
        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,

          // table: hanjiRdData.hanjiRd,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "集罐机工序生产质量记录.docx");
      });
    }
    getListData();
    onMounted(() => {});
    return {
      flHeader,
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      getListData,
      headData,
      toImage,
      imageWrapper,
      SClist,
      exportWord,
      labelName,
      editable,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}
#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}
.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}
.title_form_input {
  font-size: 16px;
}
</style>
